<template>
    <div>
        <div class="row">
            <div class="col-xs-12">
                <p id="username" v-if="getUsername !== ''"> Welcome {{ getUsername }}. </p>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12">
                <p v-if="beeHit !== ''"> You hit a {{ beeHit }} bee with {{ damageHit }} damage. </p>
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12">
                <p v-if="gameOver"> Game Over! </p>
            </div>
        </div>
        <Bees :bees="bees" :game-over="gameOver"/>
        <div class="row">
            <div class="col-xs-12">
                <button id="hit--btn" v-if="!gameOver" type="button" class="btn" @click="hit"> Hit </button>
                <button id="play-again--btn" v-else type="button" class="btn" @click="playAgain"> Play again </button>
            </div>
        </div>
    </div>
</template>

<script>
    import Bees from "./Bees";
    import { mapGetters } from 'vuex';

    export default {
        name: "Game",
        components: {Bees},
        data: () => ({
            username: '',
            beeHit: '',
            damageHit: null,
            bees: [
                {
                    id: 1,
                    type: 'queen',
                    hp: 100,
                    damage: 8,
                    hit: false,
                    died: false
                },
                {
                    id: 2,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 3,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 4,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 5,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 6,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 7,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 8,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 9,
                    type: 'worker',
                    hp: 75,
                    damage: 10,
                    hit: false,
                    died: false
                },
                {
                    id: 10,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 11,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 12,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 13,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 14,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 15,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 16,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 17,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 18,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
                {
                    id: 19,
                    type: 'drone',
                    hp: 50,
                    damage: 12,
                    hit: false,
                    died: false
                },
            ],
            randomArray: []
        }),
        computed: {
            ...mapGetters([
                'getUsername',
            ]),
            gameOver() {
                let gameOver = false;
                this.bees.forEach(bee => {
                    if(bee.id === 1 && bee.hp === 0) gameOver = true;
                });
                return gameOver;
            },
        },
        methods: {
            hit() {
                const random = this.randomArray[Math.floor(Math.random()*this.randomArray.length)];
                for (let i in this.bees) {
                    if(this.gameOver) {
                        this.bees[i].hp = 0;
                    }

                    if (this.bees[i].hp > 0 && this.bees[i].id === random.id) {
                        this.bees[i].hp = random.hp - random.damage;
                        this.beeHit = this.bees[i].type;
                        this.damageHit = random.damage;
                        this.bees[i].hit = true;
                        if (this.bees[i].hp <= 0) {
                            this.bees[i].hp = 0;
                        }
                    } else {
                        this.bees[i].hit = false;
                    }
                }

                for (let i in this.randomArray) {
                    if (this.randomArray[i].hp <= 0) {
                        if(i > -1) {
                            this.randomArray.splice(i, 1);
                        }
                    }
                }
            },

            playAgain() {
                this.randomArray = [];
                for (let i in this.bees) {
                    this.bees[i].hit = false;
                    this.bees[i].died = false;
                    if(this.bees[i].type === 'queen') {
                        this.bees[i].hp = 100;
                        this.bees[i].damage = 8;
                    } else if (this.bees[i].type === 'worker') {
                        this.bees[i].hp = 75;
                        this.bees[i].damage = 10;
                    } else {
                        this.bees[i].hp = 50;
                        this.bees[i].damage = 12;
                    }
                    this.randomArray.push(this.bees[i]);
                }

                this.gameOver = false;
                this.beeHit = '';
                this.damageHit = null;
            }
        },

        mounted() {
            for (let i in this.bees) {
                this.randomArray.push(this.bees[i]);
            }
            this.$store.dispatch('setUsername');
        }
    }
</script>

<style scoped>

</style>
